
#include "main.hpp"

// Qt include.
#include <QtCore/QCoreApplication>
#include <QtCore/QTimer>
#include <QtCore/QDebug>

// C++ include.
#include <stdexcept>


Object::Object()
	:	m_socket( new ClientSocket( this ) )
{
}

void
Object::start()
{
	m_socket->connectToHost( QHostAddress::LocalHost, 4545 );
}


int main( int argc, char ** argv )
{
	QCoreApplication app( argc, argv );

	try {
		Object object;

		QTimer::singleShot( 0, &object, SLOT( start() ) );

		return app.exec();
	}
	catch( const std::runtime_error & x )
	{
		qDebug() << x.what();
		return 1;
	}
}
