
// Qt include.
#include <QtCore/QByteArray>
#include <QtCore/QDataStream>
#include <QtCore/QDebug>

// C++ include.
#include <stdexcept>

#include "client_socket.hpp"


//
// ClientSocket
//

ClientSocket::ClientSocket( QObject * parent )
	:	QTcpSocket( parent )
{
	connect( this, SIGNAL( readyRead() ),
		SLOT( slotReadyRead() ) );
}

ClientSocket::~ClientSocket()
{
}

const quint32 c_firstNumber = 0x00010203;
const quint32 c_secondNumber = 0x03040506;
const quint16 c_count = 10;

void
ClientSocket::sendData()
{
	qDebug() << "Sending data";

	QByteArray data;

	QDataStream stream( &data, QIODevice::WriteOnly );
	stream.setVersion( QDataStream::Qt_4_0 );

	for( int i = 0; i < c_count; ++i )
		stream << c_firstNumber << c_secondNumber;

	write( data );

	flush();
}

void
ClientSocket::slotReadyRead()
{
	qDebug() << "Receiving data";

	const QByteArray data = readAll();

	QDataStream stream( data );

	quint32 firstNumber, secondNumber;

	while( !stream.atEnd() )
	{
		for( int i = 0; i < c_count; ++i )
		{
			stream >> firstNumber>> secondNumber;

			if( firstNumber != c_firstNumber ||
				secondNumber != c_secondNumber )
					throw std::runtime_error( "garbage" );
		}
	}
}
