
#ifndef SERVER_SOCKET_HPP__INCLUDED
#define SERVER_SOCKET_HPP__INCLUDED

// Qt include.
#include <QtNetwork/QTcpServer>
#include <QtCore/QScopedPointer>


//
// ServerSocket
//

class ServerSocket
	:	public QTcpServer
{
	Q_OBJECT

public:
	ServerSocket( QObject * parent = 0 );
	~ServerSocket();

	void doThis();

protected:
	//!	Process new incoming connection.
	void incomingConnection( int socketDescriptor );

private slots:
	void slotDisconnected();

private:
	Q_DISABLE_COPY( ServerSocket )

	struct ServerSocketPrivate;
	QScopedPointer< ServerSocketPrivate > d;
}; /* class ServerSocket */

#endif // SERVER_SOCKET_HPP__INCLUDED
